/*
    telecoping Task
    
*/

/* Includes ----------------------------------------------------------------- */
#include "task/user_task.h"
/* USER INCLUDE BEGIN */
#include "telescoping_gimal.h"
#include "main.h"
#include "module/config.h"
/* USER INCLUDE END */

/* Private typedef ---------------------------------------------------------- */
/* Private define ----------------------------------------------------------- */
/* Private macro ------------------------------------------------------------ */
/* Private variables -------------------------------------------------------- */
/* USER STRUCT BEGIN */
Telescoping_t telescoping;
Telescoping_CMD_t telescoping_cmd;
/* USER STRUCT END */

/* Private function --------------------------------------------------------- */
/* Exported functions ------------------------------------------------------- */
void Task_telecoping(void *argument) {
  (void)argument; /* 未使用argument，消除警告 */

  
  /* 计算任务运行到指定频率需要等待的tick数 */
  const uint32_t delay_tick = osKernelGetTickFreq() / TELECOPING_FREQ;

  osDelay(TELECOPING_INIT_DELAY); /* 延时一段时间再开启任务 */

  uint32_t tick = osKernelGetTickCount(); /* 控制任务运行频率的计时 */
  /* USER CODE INIT BEGIN */
 Telescoping_Init(&telescoping,&Config_GetRobotParam()->telescoping,
                    TELECOPING_FREQ);
		telescoping_cmd.mode=TELESCOPING_MODE_ANTI_CLOCKWISE ;
  /* USER CODE INIT END */
  
  while (1) {
    tick += delay_tick; /* 计算下一个唤醒时刻 */
    /* USER CODE BEGIN */

		Telescoping_UpdateFeedback(&telescoping);
//		osMessageQueueGet(task_runtime.msgq.telescoping.cmd, &telescoping_cmd, NULL, 0);
		Telescoping_Control(&telescoping,&telescoping_cmd); 		
		Telescoping_Output(&telescoping);
    /* USER CODE END */
    osDelayUntil(tick); /* 运行结束，等待下一次唤醒 */
  }
  
}